<?php
namespace Folha\Repositories;

class FpaIncidevento extends \Doctrine\ORM\EntityRepository
{
    public static function getSalarioRais($nrvinculom, $nrorg, $dataInicio, $dataFinal, $grupoIncide, $tipoIncide = 79)
    {
        $sql = <<<SQL
SELECT
    JANEIRO*100     AS JANEIRO,
    FEVEREIRO*100   AS FEVEREIRO,
    MARÇO*100       AS MARCO,
    ABRIL*100       AS ABRIL,
    MAIO*100        AS MAIO,
    JUNHO*100       AS JUNHO,
    JULHO*100       AS JULHO,
    AGOSTO*100      AS AGOSTO,
    SETEMBRO*100    AS SETEMBRO,
    OUTUBRO*100     AS OUTUBRO,
    NOVEMBRO*100    AS NOVEMBRO,
    DEZEMBRO*100    AS DEZEMBRO

FROM(
    SELECT
        FPA_INCIDEVENTO.IDINCIDEVENTO,
        FPA_ITECALCFOLHA.VREVENTOFOLHA,
        TO_CHAR(FPA_CALCULOFOLHA.DTOCORRENCIA, 'MM')DTOCORRENCIA
    FROM FPA_INCIDEVENTO
    INNER JOIN FPA_GRPITEM
        ON FPA_INCIDEVENTO.NRTIPOINCIDE = FPA_GRPITEM.NRTIPOINCIDE
    INNER JOIN FPA_ITECALCFOLHA
        ON FPA_ITECALCFOLHA.NREVENTOM = FPA_INCIDEVENTO.NREVENTOM
    INNER JOIN FPA_CALCULOFOLHA
        ON FPA_ITECALCFOLHA.NRCALCULOFOLHA = FPA_CALCULOFOLHA.NRCALCULOFOLHA
        AND FPA_ITECALCFOLHA.NRORG = FPA_CALCULOFOLHA.NRORG
    WHERE FPA_GRPITEM.NRGRPINCIDE = $grupoIncide
        AND FPA_INCIDEVENTO.NRTIPOINCIDE = $tipoIncide
        AND FPA_CALCULOFOLHA.DTOCORRENCIA BETWEEN TO_DATE('$dataInicio') AND TO_DATE('$dataFinal')
        AND FPA_CALCULOFOLHA.NRTIPOMOVIMENT = 1
        AND FPA_CALCULOFOLHA.NRTPMODALIDCAL = 1
        AND FPA_CALCULOFOLHA.NROCORRECAL = 1
        AND FPA_ITECALCFOLHA.NRVINCULOM = $nrvinculom
        AND FPA_ITECALCFOLHA.NRORG = $nrorg
) PIVOT (
    SUM(DECODE(IDINCIDEVENTO, '+', VREVENTOFOLHA, VREVENTOFOLHA*-1))
    FOR DTOCORRENCIA IN (
        '01'    AS  JANEIRO,
        '02'    AS  FEVEREIRO,
        '03'    AS  MARÇO,
        '04'    AS  ABRIL,
        '05'    AS  MAIO,
        '06'    AS  JUNHO,
        '07'    AS  JULHO,
        '08'    AS  AGOSTO,
        '09'    AS  SETEMBRO,
        '10'    AS  OUTUBRO,
        '11'    AS  NOVEMBRO,
        '12'    AS  DEZEMBRO))

SQL;

        $result = \Setforms2\Shared\Connection::getInstance()->fetchAll($sql);

        return ($result)?$result[0]:false;

    }

    /**
     * Função retorna uma lista com todos os tipos de incidência do evento concatenados separados por um '_'.
     *
     * @param $nrEventom
     * @param $nrorg
     * @return string
     */
    public static function retornaListaTipoIncideEvento($nrEventom, $nrorg)
    {
        $listaTipoincide = "_";

        $sql = <<<SQL
SELECT DISTINCT IE.NRTIPOINCIDE
  FROM FPA_INCIDEVENTO IE
 WHERE (IE.NRORG = 0 OR IE.NRORG = $nrorg OR IE.NRORG IS NULL)
   AND IE.NREVENTOM = $nrEventom
SQL;
        $listBase = \Setforms2\Shared\Connection::getInstance()->fetchAll($sql);

        foreach ($listBase as &$row) {
            $listaTipoincide = $listaTipoincide.$row['NRTIPOINCIDE']."_";
        }

        return $listaTipoincide;
    }

}